#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>
#include "types.h"
#include "bmp_server.h"
#include "bmp.h"
#include "main.h"

DMAIN    DatMain;

int main(int argc, char **argv)
{
	int 	scnt	= 1;
	int	res;
    	U32 	port;
	U8	_vy	= ((_BMP_version_h >> 16) & 0xFF);
	U8      _vm     = ((_BMP_version_h >> 8) & 0xFF);
	U8      _vd     = (_BMP_version_h & 0xFF);

    	printf("\r\n*** BMP File Server ***\r\n");
    	printf("BMP code version %.2X.%.2X.%.2X\r\n", _vy,_vm,_vd); 
    	//проверка наличия параметров
	if(argc < 2) 
	{
        	printf("--- Not Parametrs !!!\r\n");
		printf("--- Use \"--help\" for instruction\r\n\r\n");
        	return 1;	//нет параметров
    	}
	while(scnt < argc)
        {
                //подсказка
                if(strcmp(argv[scnt], "--help") == 0)
                {
                        printf(__help);
                        return 0;
                }
		//открытие файла
		else if(strcmp(argv[scnt], "-f") == 0)
                {
                        scnt++;
			memset(&DatMain.fname[0],0,_szfname);
			strcpy(&DatMain.fname[0], argv[scnt]);
			dat_bmp_server.ffile = fopen((char*)(&DatMain.fname[0]),"rb");
			printf("*** File %s (%i) - Open Ok!\r\n", (char*)&DatMain.fname[0], dat_bmp_server.ffile);
            		if(dat_bmp_server.ffile > 0)
            		{
                		fclose(dat_bmp_server.ffile);
                		BMP_FileAnalise((char*)(&DatMain.fname[0]));
                		dat_bmp_server.ffile = fopen((char*)(&DatMain.fname[0]),"r+b");
                		//sizeout = sprintf((char*)(dumpo), "Ok\r\n");
				printf("File %s (%i) - Open Ok!\r\n", (char*)&DatMain.fname[0], dat_bmp_server.ffile);
            		}
            		else
			{
                		//sizeout = sprintf((char*)(dumpo), "Error open file\r\n");
				printf("\r\nERROR! Not Opened File: %s\r\n\r\n", &DatMain.fname[0]);
				return 5;
			}
                }
		else if(strcmp(argv[scnt], "-p") == 0)
                {
                        scnt++;
			port = atoi(argv[scnt]);
		}
		else
                        return 4;			//неопределённый параметр
                scnt++;
	}
    	//
    	//port = atoi(argv[1]);
    	//if(BMP_FILE > 0xFF)
	//
    	BMP_SERVER_Start(port);
    	//основной рабочий цикл
	while(1)
    	{
        
        	if(dat_bmp_server.work < 1)
        	{
            		pthread_mutex_unlock(&mt);
            		break;
        	}
        	pthread_mutex_unlock(&mt);
        	usleep(1000000);
    	}
    	//
    	return 0;
}
