#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>
#include <unistd.h>
#include "types.h"
#include "socket.h"
#include "main.h"

#pragma pack(1)

CLIENT_BMP client;

pthread_t thread;

int main(int argc, char **argv)
{
    //
    U32 u32p;
    int res;
    char str[128];
    char outstr[128];
    int count;
    client.clientfd = 0;
    //
    printf("==== test ====\r\n");
    while(1)
    {
        usleep(1000000);
        memset(&str[0], 0, 128);
        gets(&str[0]);
        //
        if(strcmp(&str[0], "quit") == 0)
        {
            if(client.clientfd > 0)
            {
                TCPClientClose(client.clientfd);
                client.clientfd = 0;
            }
            break;
        }
        else if(strcmp(&str[0], "help") == 0)
            printf("%s \r\n",__help__);
        else if(strcmp(&str[0], "connect") == 0)
        {
            if(client.clientfd > 0)
                printf("--- connected ---");
            else
            {
                memset(&str[0], 0, 128);
                printf("input IP address:");
                gets(&str[0]);
                memset(&client.str_ip_addr[0], 0, 128);
                strcpy((char*)(&client.str_ip_addr[0]), (char*)(&str[0]));
                //
                //printf("IP address: %s\r\n", (char*)(&client.str_ip_addr[0]));
                memset(&str[0], 0, 128);
                printf("input IP port:");
                gets(&str[0]);
                client.ip_port = atoi(&str[0]);
                printf("IP port: %u\r\n", client.ip_port);
                //
                TCPClientInit(&client.clientfd);
                TCPClientConnect(client.clientfd,&client.str_ip_addr[0],client.ip_port);
                if(!(client.clientfd > 0))
                {
                    printf("Connect error %i\r\n", client.clientfd);
                    client.clientfd = 0;
                }
            pthread_create(&thread, NULL, RdClient,0);
            usleep(10);
            }
        }
        else if(strcmp(&str[0], "disconnect") == 0)
        {
            if(client.clientfd == 0)
                printf("Not Connected !\r\n");
            else
            {
                TCPClientClose(client.clientfd);
                printf("Disconnected\r\n");
                client.clientfd = 0;
            }
        }
        else if(strcmp(&str[0], "fileopen") == 0)
        {
            if(client.clientfd > 0)
            {
                memset(&outstr[0], 0, 128);
                count = sprintf(&outstr[0],&str[0]);
                count += sprintf(&outstr[count], " ");
                printf("Path and filename:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                printf("count %i\r\n",count);
                //
                if(!(TCPWrite(client.clientfd,&outstr[0],count) > 0))
                {
                    printf("not sended !\r\n");
                }
            }
            else
                printf("Not Connected!\r\n");
        }
        else if(strcmp(&str[0], "fileclose") == 0)
        {
            if(client.clientfd > 0)
            {
                memset(&outstr[0], 0, 128);
                count = sprintf(&outstr[0],&str[0]);
                //
                if(!(TCPWrite(client.clientfd,&outstr[0],count) > 0))
                {
                    printf("not sended !\r\n");
                }
            }
            else
                printf("Not Connected!\r\n");
        }
        else if(strcmp(&str[0], "setpixel") == 0)
        {
            if(client.clientfd > 0)
            {
                memset(&outstr[0], 0, 128);
                count = sprintf(&outstr[0],&str[0]);
                count += sprintf(&outstr[count], " ");
                printf("X:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("Y:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("R:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("G:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("B:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                if(!(TCPWrite(client.clientfd,&outstr[0],count) > 0))
                {
                    printf("not sended !\r\n");
                }
            }
            else
                printf("Not Connected!\r\n");
        }
        else if(strcmp(&str[0], "circle") == 0)
        {
            if(client.clientfd > 0)
            {
                memset(&outstr[0], 0, 128);
                count = sprintf(&outstr[0],&str[0]);
                count += sprintf(&outstr[count], " ");
                printf("X:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("Y:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("RADIUS:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("R:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("G:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("B:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                if(!(TCPWrite(client.clientfd,&outstr[0],count) > 0))
                {
                    printf("not sended !\r\n");
                }
            }
            else
                printf("Not Connected!\r\n");
        }
        else if(strcmp(&str[0], "circlefill") == 0)
        {
            if(client.clientfd > 0)
            {
                memset(&outstr[0], 0, 128);
                count = sprintf(&outstr[0],&str[0]);
                count += sprintf(&outstr[count], " ");
                printf("X:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("Y:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("RADIUS:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("R:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("G:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("B:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                if(!(TCPWrite(client.clientfd,&outstr[0],count) > 0))
                {
                    printf("not sended !\r\n");
                }
            }
            else
                printf("Not Connected!\r\n");
        }
        else if(strcmp(&str[0], "circlefill_fuzzy") == 0)
        {
            if(client.clientfd > 0)
            {
                memset(&outstr[0], 0, 128);
                count = sprintf(&outstr[0],&str[0]);
                count += sprintf(&outstr[count], " ");
                printf("X:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("Y:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("RADIUS:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("R:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("G:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("B:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("FUZZY:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                if(!(TCPWrite(client.clientfd,&outstr[0],count) > 0))
                {
                    printf("not sended !\r\n");
                }
            }
            else
                printf("Not Connected!\r\n");
        }
        else if(strcmp(&str[0], "rect") == 0)
        {
            if(client.clientfd > 0)
            {
                memset(&outstr[0], 0, 128);
                count = sprintf(&outstr[0],&str[0]);
                count += sprintf(&outstr[count], " ");
                printf("X1:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("Y1:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("X2:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("Y2:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("R:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("G:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("B:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                if(!(TCPWrite(client.clientfd,&outstr[0],count) > 0))
                {
                    printf("not sended !\r\n");
                }
            }
            else
                printf("Not Connected!\r\n");
        }
        else if(strcmp(&str[0], "rect_filled") == 0)
        {
            if(client.clientfd > 0)
            {
                memset(&outstr[0], 0, 128);
                count = sprintf(&outstr[0],&str[0]);
                count += sprintf(&outstr[count], " ");
                printf("X1:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("Y1:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("X2:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("Y2:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("R:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("G:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("B:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                if(!(TCPWrite(client.clientfd,&outstr[0],count) > 0))
                {
                    printf("not sended !\r\n");
                }
            }
            else
                printf("Not Connected!\r\n");
        }
        else if(strcmp(&str[0], "triangle") == 0)
        {
            if(client.clientfd > 0)
            {
                memset(&outstr[0], 0, 128);
                count = sprintf(&outstr[0],&str[0]);
                count += sprintf(&outstr[count], " ");
                printf("X1:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("Y1:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("X2:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("Y2:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                 //
                count += sprintf(&outstr[count], " ");
                printf("X3:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("Y3:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("R:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("G:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("B:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                if(!(TCPWrite(client.clientfd,&outstr[0],count) > 0))
                {
                    printf("not sended !\r\n");
                }
            }
            else
                printf("Not Connected!\r\n");
        }
        else if(strcmp(&str[0], "line") == 0)
        {
            if(client.clientfd > 0)
            {
                memset(&outstr[0], 0, 128);
                count = sprintf(&outstr[0],&str[0]);
                count += sprintf(&outstr[count], " ");
                printf("X1:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("Y1:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("X2:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("Y2:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                 //
                count += sprintf(&outstr[count], " ");
                printf("R:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count+= sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("G:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                count += sprintf(&outstr[count], " ");
                printf("B:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                count += sprintf(&outstr[count],&str[0]);
                //
                if(!(TCPWrite(client.clientfd,&outstr[0],count) > 0))
                {
                    printf("not sended !\r\n");
                }
            }
            else
                printf("Not Connected!\r\n");
        }
        /******* BINARY MODE ******/
        else if(strcmp(&str[0], "bsetpixel") == 0)
        {
            if(client.clientfd > 0)
            {
                memset(&outstr[0], 0, 128);
                outstr[_id_in_bin_addr] = _id_bin; //1
                (*(U32*)(&outstr[_size_in_addr])) = (U32)(_bmp_cmd_ssetpixel); //4
                //
                //u32p = (U32)(_bmp_cmd_setpixel);
                //memcpy(&outstr[_incmd_addr], &u32p,  sizeof(U16));
                (*(U16*)(&outstr[_incmd_addr])) =(U16)( _bmp_cmd_setpixel); //2
                printf("X:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                (*(U32*)(&outstr[_addr_setpixel_X1])) = (U32)(atoi(&str[0])); //4
                printf("Y:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                (*(U32*)(&outstr[_addr_setpixel_Y1])) = atoi(&str[0]);//4
                printf("R:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                outstr[_addr_setpixel_R] = (BYTE)(atoi(&str[0])); //1
                printf("G:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                outstr[_addr_setpixel_G] = (BYTE)(atoi(&str[0])); //1
                printf("B:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                outstr[_addr_setpixel_B] = (BYTE)(atoi(&str[0])); //1
                //
                printf("flag  %x ----\r\n",(*(U8*)(&outstr[_id_in_bin_addr])));
                printf("size  %x ----\r\n",(*(U32*)(&outstr[ _size_in_addr])));
                printf("cmd  %x ----\r\n",(*(U16*)(&outstr[_incmd_addr])));
                res = TCPWrite(client.clientfd, &outstr[0], _bmp_cmd_ssetpixel );
                if(!( res > 0))
                {
                    printf("not sended !\r\n");
                }
                else
                    printf("sending %u  res %i\r\n", (*(U32*)(&outstr[_size_in_addr])), res);
            }
            else
                printf("Not Connected!\r\n");
        }
        else if(strcmp(&str[0], "bline") == 0)
        {
            if(client.clientfd > 0)
            {
                memset(&outstr[0], 0, 128);
                outstr[_id_in_bin_addr] = _id_bin; //1
                (*(U32*)(&outstr[_size_in_addr])) = (U32)(_bmp_cmd_sline); //4
                //
                //u32p = (U32)(_bmp_cmd_setpixel);
                //memcpy(&outstr[_incmd_addr], &u32p,  sizeof(U16));
                (*(U16*)(&outstr[_incmd_addr])) =(U16)( _bmp_cmd_line); //2
                printf("X1:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                (*(U32*)(&outstr[_addr_line_X1])) = (U32)(atoi(&str[0])); //4
                printf("Y1:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                (*(U32*)(&outstr[_addr_line_Y1])) = atoi(&str[0]);//4
                printf("X2:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                (*(U32*)(&outstr[_addr_line_X2])) = (U32)(atoi(&str[0])); //4
                printf("Y2:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                (*(U32*)(&outstr[_addr_line_Y2])) = atoi(&str[0]);//4
                printf("R:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                outstr[_addr_line_R] = (BYTE)(atoi(&str[0])); //1
                printf("G:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                outstr[_addr_line_G] = (BYTE)(atoi(&str[0])); //1
                printf("B:");
                memset(&str[0], 0, 128);
                gets(&str[0]);
                outstr[_addr_line_B] = (BYTE)(atoi(&str[0])); //1
                //
                printf("flag  %x ----\r\n",(*(U8*)(&outstr[_id_in_bin_addr])));
                printf("size  %x ----\r\n",(*(U32*)(&outstr[ _size_in_addr])));
                printf("cmd  %x ----\r\n",(*(U16*)(&outstr[_incmd_addr])));
                res = TCPWrite(client.clientfd, &outstr[0], _bmp_cmd_sline );
                if(!( res > 0))
                {
                    printf("not sended !\r\n");
                }
                else
                    printf("sending %u  res %i\r\n", (*(U32*)(&outstr[_size_in_addr])), res);
            }
            else
                printf("Not Connected!\r\n");
        }
        else
        {
            printf("Command error!\r\n");
            printf("-- input \"help\" for INFO --\r\n"); 
        }
        usleep(10);
    }
	return 0;
}

void RdClient(void)
{
    char rdbuf[128];
    while(client.clientfd > 0)
    {
        memset(&rdbuf[0],0,128);
        TCPNonBlockRead(client.clientfd, &rdbuf[0],128);
        printf("%s", &rdbuf[0]);
        usleep(10);
    }
}
